unsafe extern "C" fn _enter() -> ! {
    let id = riscv::register::mhartid::read();
    crate::entry::write_tp(&id);
}

#[inline]
unsafe fn write_tp(id: &usize) -> ! {
    use core::arch::asm;
    asm!(
        "csrw mhartid, {id}",
        id = in(reg) id,
        options(noreturn)
    );
}